const _Http = getApp().globalData.http;

import {
    getTypes
} from "./modules/query";

Page({
    data: {
        loading: true,
        navList: [{
            label: "我负责的",
            icon: "icon-webxialaxuanxiangjiantou",
            color: "",
            width: "",
            id: "1"
        }, {
            label: "排序",
            icon: "icon-jiangxu1",
            color: "",
            width: "",
            id: "sort"
        }, {
            label: "筛选",
            icon: "icon-shaixuan",
            color: "",
            width: "",
            id: "2"
        }],
        content: {
            isend: 0,
            nocache: true,
            "type": 1,
            deleted: 0,
            "pageNumber": 1,
            "pageSize": 20,
            "isExport": 0,
            "where": {},
            "sort": [{
                sortname: "默认",
                sorted: 1,
                sortid: 67,
                reversed: 0
            }]
        },
        list: [],
        classShow: false, //type类型

    },
    /* 去添加 */
    toAdd() {
        wx.navigateTo({
            url: './addAndEditor'
        })
    },
    async onLoad(options) {
        getApp().globalData.Language.getLanguagePackage(this, '医院管理');
        this.setData({
            insert: wx.getStorageSync('auth').wCustomer.options.some(v => v == 'insert'), //查询新增权限
            classActions: wx.getStorageSync('templetList').map((v, i) => {
                return {
                    name: v.templetname,
                    index: v.templetid,
                    color: i == 0 ? '#3874F6' : '',
                    i: i,
                }
            }),
            'navList[0].label': wx.getStorageSync('templetList')[0].templetname,
            "content.type": wx.getStorageSync('templetList')[0].templetid,
        });
        this.getList()
        let filtratelist = [{
            label: "部门",
            index: null,
            showName: "depname", //显示字段
            valueKey: "sa_saleareaid", //返回Key
            selectKey: "sa_saleareaid", //传参 代表选着字段 不传参返回整个选择对象
            value: "", //选中值
            type: 'multilevelClass',
            list: await _Http.basic({
                "id": 20230620102004,
                "content": {},
            }).then(res => {
                console.log("获取部门", res)
                return res.data.dep
            })
        }, {
            label: "医院类型",
            index: null,
            showName: "value", //显示字段
            valueKey: "type", //返回Key
            selectKey: "value", //传参 代表选着字段 不传参返回整个选择对象
            value: "", //选中值
            list: await getTypes('customertypemx')
        }, {
            label: "合作状态",
            index: null,
            showName: "value", //显示字段
            valueKey: "status", //返回Key
            selectKey: "value", //传参 代表选着字段 不传参返回整个选择对象
            value: "", //选中值
            list: [{
                value: "潜在"
            }, {
                value: "合作中"
            }, {
                value: "已终止"
            }, {
                value: "暂缓"
            }]
        }, {
            label: "成交状态",
            index: null,
            showName: "value", //显示字段
            valueKey: "tradingstatus", //返回Key
            selectKey: "value", //传参 代表选着字段 不传参返回整个选择对象
            value: "", //选中值
            list: [{
                value: "未成交"
            }, {
                value: "已成交"
            }, {
                value: "多次成交"
            }]
        }, {
            label: "标签",
            index: null,
            type: "checkbox",
            showName: "tag", //显示字段
            valueKey: "tag", //返回Key
            selectKey: "tag", //传参 代表选着字段 不传参返回整个选择对象
            value: "", //选中值
            list: await getTypes('tags')
        }]
        this.setData({
            filtratelist
        })
    },
    /* 处理筛选 */
    handleFilter({
        detail
    }) {
        detail.condition = this.data.content.where.condition;
        this.data.content.where = detail;
        this.getList(true);
    },
    getList(init = false) {
        _Http.init(this.data.content, init).then(content => {
            _Http.basic({
                "id": 20221012164402,
                content
            }).then(res => {
                console.log("客户列表", res)
                this.selectComponent('#ListBox').RefreshToComplete();
                if (res.code != '1') return wx.showToast({
                    title: res.msg,
                    icon: "none"
                })
                this.setData({
                    loading: false,
                    content: _Http.paging(content, res),
                    list: res.pageNumber == 1 ? res.data : this.data.list.concat(res.data)
                })
                this.getTags();
            })
        })
    },
    /* 获取列表标签 */
    getTags() {
        let list = this.data.list,
            ownerids = list.map(v => v.sa_customersid)
        _Http.basic({
            "id": 20221018102001,
            "content": {
                "ownertable": "sa_customers",
                ownerids
            }
        }).then(res => {
            for (let key in res.data) {
                let index = list.findIndex(v => v.sa_customersid == key);
                list[index].tags = res.data[key]
            };
            this.setData({
                list
            })
        })
    },
    /* 顶部条件导航回调 */
    navClick({
        detail
    }) {
        switch (detail.id) {
            case '1':
                this.setData({
                    classShow: true
                })
                break;
            case '2':
                this.setData({
                    'filterShow': true
                })
                break;
            case '3':
                this.setData({
                    'content.sort[0].reversed': this.data.content.sort[0].reversed == 0 ? 1 : 0
                });
                this.getList(true)
                break;
            default:

                break;
        }
    },
    /* 处理搜索 */
    onSearch({
        detail
    }) {
        this.data.content.where.condition = detail;
        this.getList(true);
    },
    classClose() {
        this.setData({
            classShow: false
        })
    },
    classSelect({
        detail
    }) {
        if (this.data.content.type == detail.index) return this.classClose();
        this.setData({
            "content.type": detail.index,
            'navList[0].label': detail.name,
            classActions: this.data.classActions.map(v => {
                v.color = detail.i == v.i ? '#3874F6' : ''
                return v
            })
        })
        this.classClose();
        this.getList(true)
    }
})